{ config, pkgs, ... }:

{
  environment.systemPackages = with pkgs.haskellPackages; with pkgs; [
    gitg
    gmpc
    m4
    openjdk8
    sbt scala
    chromium
    qalculate-gtk
    speedcrunch
    viewnior
    gnupg
    pass xclip pwgen
    remmina
    ledger
    hledger
    # hledger-diff
    cmake ninja
    mpv
    neomutt notmuch
    patchelf
    loc
    ripgrep
    imagemagick
    mercurial

    alacritty

    androidenv.platformTools # adb & fastboot

    lm_sensors
    hdparm
    lsof

    pdfpc

    # emacs
    emacs
    ghostscript # for auctex
    aspell

    nodejs-9_x

    mediainfo

    isync
    msmtp
    vdirsyncer khard khal

    linuxPackages.perf

    veriT
    minisat
    picosat
    glucose
    prover9
    eprover
    metis-prover
    spass
    z3
    cvc4
    graphviz
    # toysolver

    emacsPackages.proofgeneral
  ] ++ (with aspellDicts; [ en de fr nl ]);

  nixpkgs.config.packageOverrides = pkgs: with pkgs; let
    fetchNixPkgs = { rev, sha256 }:
    fetchFromGitHub {
      inherit sha256 rev;
      owner = "NixOS";
      repo = "nixpkgs-channels";
    };
    stablePkgs = fetchNixPkgs {
      rev = "1a8a95e87962bc8ff8514b28e026fc987fbdb010";
      sha256 = "1rx14g8wlw6vdjalsv6rnznmfsazwf218rv75z9ac2vdgwihclxh";
    };
  in {
    # idea-community-eap = pkgs.idea.idea-community.overrideDerivation (oldAttrs: rec {
    #     name = "idea-community-${version}";
    #     version = "2017.2.eap";
    #     src = pkgs.fetchurl {
    #       url = "https://download.jetbrains.com/idea/ideaIC-172.3544.6-no-jdk.tar.gz";
    #       sha256 = "72874a0393a6388b04353a359eea1d1242f59d6e7b96a4cf43c793602ac7ccdb";
    #     };
    #   });
    idea-community-eap = pkgs.idea.idea-community;

    # clion-eap = pkgs.idea.clion.overrideDerivation (oldAttrs: rec {
    #   name = "clion-${version}";
    #   version = "2017.1.eap";
    #   src = pkgs.fetchurl {
    #     url = "http://download.jetbrains.com/cpp/CLion-2017.1-RC.tar.gz";
    #     sha256 = "1rv9rcjv4kv39l9r4g5kqbd4y175301a6kr3js3szkjmhqd50qq3";
    #   };
    # });
    clion-eap = pkgs.idea.clion;

    # neovim = pkgs.neovim.override {
    #   extraPythonPackages = [ pkgs.pythonPackages.websocket_client ];
    # };

    stablePkgs = stablePkgs;
    stable = import stablePkgs {};
  };

  nixpkgs.config.allowTexliveBuilds = true;
  nixpkgs.config.allowUnfree = true;

}
